import { defineComponent as O, shallowRef as _, computed as h, onMounted as X, createVNode as y, reactive as H, onBeforeUnmount as J, watch as U, mergeProps as C, ref as K, isVNode as Q } from "vue";
function k() {
  return typeof window < "u" && "IntersectionObserver" in window && "isIntersecting" in window.IntersectionObserverEntry.prototype;
}
const x = {}, p = (e) => {
  e.forEach((t) => {
    t.isIntersecting && t.target.onVisible();
  });
}, ee = (e) => (x[e] = x[e] || new IntersectionObserver(p, {
  rootMargin: e + "px"
}), x[e]), F = () => typeof window > "u" ? 0 : window.scrollX || window.pageXOffset, z = () => typeof window > "u" ? 0 : window.scrollY || window.pageYOffset, B = () => ({
  afterLoad: {
    type: Function,
    default: () => {
    }
  },
  beforeLoad: {
    type: Function,
    default: () => {
    }
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  visibleByDefault: {
    type: Boolean,
    default: !1
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  delayMethod: {
    type: String,
    default: "throttle"
  },
  delayTime: {
    type: Number,
    default: 300
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), te = () => ({
  ...B(),
  onImageError: {
    type: Function,
    default: () => {
    }
  },
  effect: {
    type: String,
    default: ""
  },
  placeholderSrc: {
    type: String,
    default: ""
  },
  wrapperClassName: {
    type: String,
    default: ""
  },
  wrapperProps: {
    type: Object,
    default: () => ({})
  },
  loadedClassName: {
    type: String,
    default: ""
  }
}), ne = () => ({
  style: {
    type: Object,
    default: () => {
    }
  },
  class: {
    type: String,
    default: ""
  },
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 100
  },
  width: {
    type: Number,
    default: 100
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), re = () => ({
  scrollPosition: {
    type: Object,
    default: null
  },
  useIntersectionObserver: {
    type: Boolean,
    default: !0
  },
  threshold: {
    type: Number,
    default: 300
  },
  onVisible: {
    type: Function,
    default: () => {
    }
  },
  height: {
    type: Number,
    default: 0
  },
  width: {
    type: Number,
    default: 0
  },
  placeholder: {
    type: Object,
    default: () => {
    }
  }
}), Y = /* @__PURE__ */ O({
  name: "PlaceholderWithoutTracking",
  inheritAttrs: !1,
  props: ne(),
  setup(e) {
    const t = _(), r = h(() => !e.scrollPosition && e.useIntersectionObserver && k()), o = h(() => r.value ? ee(e.threshold) : null);
    function c(l = e.scrollPosition) {
      const n = t.value.getBoundingClientRect(), s = t.value.style, f = {
        left: parseInt(s.getPropertyValue("margin-left"), 10) || 0,
        top: parseInt(s.getPropertyValue("margin-top"), 10) || 0
      };
      return {
        bottom: l.y + n.bottom + f.top,
        left: l.x + n.left + f.left,
        right: l.x + n.right + f.left,
        top: l.y + n.top + f.top
      };
    }
    function d() {
      if (typeof window > "u" || t.value)
        return !1;
      const l = c(e.scrollPosition), n = {
        bottom: e.scrollPosition.y + window.innerHeight,
        left: e.scrollPosition.x,
        right: e.scrollPosition.x + window.innerWidth,
        top: e.scrollPosition.y
      };
      return n.top - e.threshold <= l.bottom && n.bottom + e.threshold >= l.top && n.left - e.threshold <= l.right && n.right + e.threshold >= l.left;
    }
    function a() {
      var l;
      d() && ((l = e.onVisible) == null || l.call(e));
    }
    X(() => {
      o.value && t.value && (t.value.onVisible = e.onVisible, o.value.observe(t.value)), r.value || a == null || a();
    });
    const i = h(() => ({
      display: "inline-block",
      height: `${e.height}px`,
      width: `${e.width}px`,
      ...e.style
    }));
    return () => y("span", {
      ref: t,
      style: i.value
    }, [e.placeholder]);
  }
});
var ie = typeof global == "object" && global && global.Object === Object && global;
const le = ie;
var oe = typeof self == "object" && self && self.Object === Object && self, ae = le || oe || Function("return this")();
const G = ae;
var ce = G.Symbol;
const L = ce;
var Z = Object.prototype, ue = Z.hasOwnProperty, de = Z.toString, w = L ? L.toStringTag : void 0;
function se(e) {
  var t = ue.call(e, w), r = e[w];
  try {
    e[w] = void 0;
    var o = !0;
  } catch {
  }
  var c = de.call(e);
  return o && (t ? e[w] = r : delete e[w]), c;
}
var fe = Object.prototype, ge = fe.toString;
function he(e) {
  return ge.call(e);
}
var ye = "[object Null]", be = "[object Undefined]", A = L ? L.toStringTag : void 0;
function me(e) {
  return e == null ? e === void 0 ? be : ye : A && A in Object(e) ? se(e) : he(e);
}
function ve(e) {
  return e != null && typeof e == "object";
}
var we = "[object Symbol]";
function Oe(e) {
  return typeof e == "symbol" || ve(e) && me(e) == we;
}
var Pe = /\s/;
function Ie(e) {
  for (var t = e.length; t-- && Pe.test(e.charAt(t)); )
    ;
  return t;
}
var Se = /^\s+/;
function Le(e) {
  return e && e.slice(0, Ie(e) + 1).replace(Se, "");
}
function T(e) {
  var t = typeof e;
  return e != null && (t == "object" || t == "function");
}
var R = 0 / 0, Te = /^[-+]0x[0-9a-f]+$/i, je = /^0b[01]+$/i, Ee = /^0o[0-7]+$/i, xe = parseInt;
function D(e) {
  if (typeof e == "number")
    return e;
  if (Oe(e))
    return R;
  if (T(e)) {
    var t = typeof e.valueOf == "function" ? e.valueOf() : e;
    e = T(t) ? t + "" : t;
  }
  if (typeof e != "string")
    return e === 0 ? e : +e;
  e = Le(e);
  var r = je.test(e);
  return r || Ee.test(e) ? xe(e.slice(2), r ? 2 : 8) : Te.test(e) ? R : +e;
}
var Ne = function() {
  return G.Date.now();
};
const N = Ne;
var Ce = "Expected a function", ke = Math.max, Be = Math.min;
function q(e, t, r) {
  var o, c, d, a, i, l, n = 0, s = !1, f = !1, b = !0;
  if (typeof e != "function")
    throw new TypeError(Ce);
  t = D(t) || 0, T(r) && (s = !!r.leading, f = "maxWait" in r, d = f ? ke(D(r.maxWait) || 0, t) : d, b = "trailing" in r ? !!r.trailing : b);
  function P(u) {
    var g = o, m = c;
    return o = c = void 0, n = u, a = e.apply(m, g), a;
  }
  function W(u) {
    return n = u, i = setTimeout(v, t), s ? P(u) : a;
  }
  function V(u) {
    var g = u - l, m = u - n, S = t - g;
    return f ? Be(S, d - m) : S;
  }
  function j(u) {
    var g = u - l, m = u - n;
    return l === void 0 || g >= t || g < 0 || f && m >= d;
  }
  function v() {
    var u = N();
    if (j(u))
      return E(u);
    i = setTimeout(v, V(u));
  }
  function E(u) {
    return i = void 0, b && o ? P(u) : (o = c = void 0, a);
  }
  function M() {
    i !== void 0 && clearTimeout(i), n = 0, o = l = c = i = void 0;
  }
  function $() {
    return i === void 0 ? a : E(N());
  }
  function I() {
    var u = N(), g = j(u);
    if (o = arguments, c = this, l = u, g) {
      if (i === void 0)
        return W(l);
      if (f)
        return clearTimeout(i), i = setTimeout(v, t), P(l);
    }
    return i === void 0 && (i = setTimeout(v, t)), a;
  }
  return I.cancel = M, I.flush = $, I;
}
var We = "Expected a function";
function Ve(e, t, r) {
  var o = !0, c = !0;
  if (typeof e != "function")
    throw new TypeError(We);
  return T(r) && (o = "leading" in r ? !!r.leading : o, c = "trailing" in r ? !!r.trailing : c), q(e, t, {
    leading: o,
    maxWait: t,
    trailing: c
  });
}
const Me = (e) => {
  const t = getComputedStyle(e, null);
  return t.getPropertyValue("overflow") + t.getPropertyValue("overflow-y") + t.getPropertyValue("overflow-x");
}, $e = (e) => {
  if (!(e instanceof HTMLElement))
    return window;
  let t = e;
  for (; t && t instanceof HTMLElement; ) {
    if (/(scroll|auto)/.test(Me(t)))
      return t;
    t = t.parentNode;
  }
  return window;
}, Fe = (e) => /* @__PURE__ */ O({
  name: "ScrollAwareComponent",
  props: B(),
  setup(t, {
    attrs: r
  }) {
    const o = h(() => t.useIntersectionObserver && k()), c = _(null), d = H({
      x: F(),
      y: z()
    });
    if (!o.value)
      return null;
    function a() {
      o.value || (d.x = F(), d.y = z());
    }
    const i = h(() => $e(c.value));
    function l() {
      typeof window > "u" || o || (i.value.addEventListener("scroll", a), window.addEventListener("resize", a), i.value !== document.body && window.addEventListener("scroll", a));
    }
    function n() {
      typeof window > "u" || o || (i.value.removeEventListener("scroll", a), window.removeEventListener("resize", a), i.value !== document.body && window.removeEventListener("scroll", a));
    }
    X(() => {
      l();
    }), J(() => {
      n();
    }), U(i, (f, b) => {
      b && n(), l();
    });
    const s = t.delayMethod === "debounce" ? q(a, t.delayTime) : Ve(a, t.delayTime);
    return () => y(e, C(t, r, {
      scrollPosition: d,
      ref: c,
      onChangeScroll: s
    }), null);
  }
}), ze = /* @__PURE__ */ O({
  compatConfig: {
    MODE: 3
  },
  name: "PlaceholderWithTracking",
  inheritAttrs: !1,
  props: re(),
  setup(e) {
    return () => y(Y, e, null);
  }
}), Ae = Fe(ze), Re = /* @__PURE__ */ O({
  compatConfig: {
    MODE: 3
  },
  name: "LazyLoadComponent",
  inheritAttrs: !1,
  props: B(),
  setup(e, {
    slots: t
  }) {
    var d, a;
    const r = H({
      visible: e.visibleByDefault ?? !1,
      loaded: !1,
      error: !1
    }), o = h(() => !!(e.scrollPosition && Number.isFinite(e.scrollPosition.x) && e.scrollPosition.x >= 0 && Number.isFinite(e.scrollPosition.y) && e.scrollPosition.y >= 0));
    U(r, (i, l) => {
      var n;
      i.visible !== (l == null ? void 0 : l.visible) && ((n = e.afterLoad) == null || n.call(e));
    }, {
      immediate: !0
    });
    const c = () => {
      var i;
      r.visible = !0, (i = e.afterLoad) == null || i.call(e);
    };
    return e.visibleByDefault && ((d = e.beforeLoad) == null || d.call(e), (a = e.afterLoad) == null || a.call(e)), () => {
      var i;
      return r.visible ? (i = t.default) == null ? void 0 : i.call(t) : o.value || e.useIntersectionObserver && k() ? y(Y, {
        height: e.height,
        onVisible: c,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width,
        style: e.style,
        class: e.class
      }, null) : y(Ae, {
        height: e.height,
        onVisible: c,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        width: e.width,
        style: e.style,
        class: e.class
      }, null);
    };
  }
});
function De(e) {
  return typeof e == "function" || Object.prototype.toString.call(e) === "[object Object]" && !Q(e);
}
const Xe = /* @__PURE__ */ O({
  name: "LazyLoadImage",
  inheritAttrs: !1,
  compatConfig: {
    MODE: 3
  },
  props: te(),
  setup(e, {
    attrs: t
  }) {
    const r = K(!1);
    function o() {
      if (!r.value)
        return (n) => {
          var s;
          (s = e.afterLoad) == null || s.call(e, n), r.value = !0;
        };
    }
    function c() {
      const n = h(() => {
        const {
          afterLoad: s,
          beforeLoad: f,
          delayMethod: b,
          delayTime: P,
          effect: W,
          placeholder: V,
          placeholderSrc: j,
          scrollPosition: v,
          threshold: E,
          useIntersectionObserver: M,
          visibleByDefault: $,
          wrapperClassName: I,
          wrapperProps: u,
          loadedClassName: g,
          onImageError: m,
          ...S
        } = e;
        return S;
      });
      return y("img", C({
        onLoad: o(),
        onError: e.onImageError
      }, n.value, t), null);
    }
    function d() {
      let n;
      return y(Re, {
        beforeLoad: e.beforeLoad,
        class: e.class,
        delayMethod: e.delayMethod,
        delayTime: e.delayTime,
        height: e.height,
        placeholder: e.placeholder,
        scrollPosition: e.scrollPosition,
        style: e.style,
        threshold: e.threshold,
        useIntersectionObserver: e.useIntersectionObserver,
        visibleByDefault: e.visibleByDefault,
        width: e.width
      }, De(n = c()) ? n : {
        default: () => [n]
      });
    }
    const a = h(() => r.value ? " lazy-load-image-loaded" : ""), i = h(() => r.value || !e.placeholderSrc ? {} : {
      backgroundImage: `url(${e.placeholderSrc})`,
      backgroundSize: "100% 100%"
    });
    function l(n) {
      return y("span", C({
        class: e.wrapperClassName + " lazy-load-image-background " + e.effect + a.value,
        style: {
          ...i.value,
          color: "transparent",
          display: "inline-block",
          height: e.height + "px",
          width: e.width + "px"
        }
      }, e.wrapperProps), [n]);
    }
    return () => {
      const n = d();
      return !((e.effect || e.placeholderSrc) && !e.visibleByDefault) && !e.wrapperClassName && !e.wrapperProps ? n : l(n);
    };
  }
});
export {
  Re as LazyLoadComponent,
  Xe as LazyLoadImage,
  Fe as trackWindowScroll
};
